###############
# other funs.R
###############
# There are four functions defined in this file. 

# 'mae' and 'mse' functions are used to calculate mae and mse values. "na.rm" is added to
# the existing functions. First input is the forecast value and second the true value.

# 'error' function is used to calculate mae and mse errors at each forecast horizon h 
# for functions. First input is the true value and second input is the forecast value. The 
# forecast value is in the form of a list with the hth element as the h-step-ahead forecast.

# 'int.score' function is used to calculate interval score at each forecast horizon h. First
# input is the true function value. The second input is the lower bound and third upper bound,
# both are a list with the hth element as the h-step-ahead forecast. alpha is 1-significance level.

# The existing function 'smooth.demogdata' is updated by adding the smoothing variance.

###########
# FVECM. R
###########
# There are three functionns defined in this file.

# 'VECMB.ys' is used to construct a VECM series with specified coefficient matrix and residuals.
# It is a function modified from 'VARB.ys'. x are the orginial values and only the first p values 
# are used to start the serie. p is the lag of the model's VAR form. b is the specified coefficient 
# matrix of the VAR form. e are the specified residuals. type is either 'constant' or 'constant + trend'.

# 'fvecm' is used to fit an FVECM model to demogdata generated by 'read.demogdata'. Input k is the 
# order. The function outputs the fitted functions for female and male rates, the basis functions,
# and also the fitted model for each pair of scores.

# 'forecast.fvecm' is a function used to make forecats for objects generated by 'fvecm'. The input 'h'
# is the forecast horizon. 'level' is the nominal coverage probability, and 'nboot' is the number of
# bootstraps to be used to calculate prediction interval. The function outputs the point forecats, 
# interval forecasts as well as the bootstrap samples.

##########
# FVAR. R
##########
# There are three functions defined in this file.

# The function 'VAR.BPR' is updated by adding the bootstrap sample as an output.

# 'fvecm' is used to fit an FVAR model to demogdata generated by 'read.demogdata'. Input k is the 
# order. The function outputs the fitted functions for female and male rates, the basis functions,
# and also the principal component scores for female and male data.

# 'forecast.fvar' is a function used to make forecats for objects generated by 'fvar'. The input 'h'
# is the forecast horizon. 'level' is the nominal coverage probability, and 'nboot' is the number of
# bootstraps to be used to calculate prediction interval. The function outputs the point forecats, 
# interval forecasts as well as the bootstrap samples.

###############
# expand.win.R
###############
# Within the expanding-window loop, the univariate, the VAR, the VECM and the product-ratio approach
# are all applied to the age- and sex-specific mortality rates of one country. Here the order K is 
# pre-chosen. But in the univariate and PR models, the number of components is set to be 6.

